!{\src2tex{textfont=tt}}
!!****f* ABINIT/wvl_denspot_free
!! NAME
!!  wvl_denspot_free
!!
!! FUNCTION
!!  FIXME: add description.
!!
!! COPYRIGHT
!!  Copyright (C) 2012-2013 ABINIT group (FIXME: add author)
!!  This file is distributed under the terms of the
!!  GNU General Public License, see ~abinit/COPYING
!!  or http://www.gnu.org/copyleft/gpl.txt .
!!
!! INPUTS
!!  argin(sizein)=description
!!
!! OUTPUT
!!  argout(sizeout)=description
!!
!! SIDE EFFECTS
!!
!! NOTES
!!
!! PARENTS
!!      gstate,wvl_wfsinp_reformat
!!
!! CHILDREN
!!      deallocate_denspot_distribution,deallocate_rho_descriptors
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

#include "abi_common.h"

subroutine wvl_denspot_free(den)
    
 use defs_basis
 use defs_wvltypes
 use m_profiling
 use m_errors
#if defined HAVE_DFT_BIGDFT
 use BigDFT_API
#endif

!This section has been created automatically by the script Abilint (TD).
!Do not modify the following lines by hand.
#undef ABI_FUNC
#define ABI_FUNC 'wvl_denspot_free'
!End of the abilint section

 implicit none

!Arguments ------------------------------------
 type(wvl_denspot_type), intent(inout) :: den

!Local variables-------------------------------
#ifndef HAVE_DFT_BIGDFT
 character(len=500) :: message
#endif
 
! *************************************************************************
 
!DEBUG
!write (std_out,*) ' wvl_denspot_free : enter'
!ENDDEBUG

#if defined HAVE_DFT_BIGDFT
 call deallocate_denspot_distribution(den%denspot%dpbox, ABI_FUNC)
 call deallocate_rho_descriptors(den%denspot%rhod, ABI_FUNC)
 ABI_DEALLOCATE(den%denspot%V_xc)
 ABI_DEALLOCATE(den%denspot%V_ext)
 ABI_DEALLOCATE(den%denspot%rhov)
 nullify(den%denspot%pkernel)
 nullify(den%denspot%pkernelseq)
#else
 write(message, '(a,a,a,a)' ) ch10,&
& ' wvl_wfs_free: BigDFT library is not compiled.', ch10, &
& '   Action, used the flag --enable-bigdft when configuring.'
 MSG_ERROR(message)
#endif

!DEBUG
!write (std_out,*) ' wvl_denspot_free : exit'
!stop
!ENDDEBUG

end subroutine wvl_denspot_free
!!***
