!{\src2tex{textfont=tt}}
!!****f* ABINIT/paw_atdata_deallocate
!! NAME
!!  paw_atdata_deallocate
!!
!! FUNCTION
!!  Deallocate paw_atdata_type
!!
!! COPYRIGHT
!!  Copyright (C) 2013 ABINIT group (T. Rangel)
!!  This file is distributed under the terms of the
!!  GNU General Public License, see ~abinit/COPYING
!!  or http://www.gnu.org/copyleft/gpl.txt .
!!
!! INPUTS
!!  paw_atdata: object with atomic data
!!
!! OUTPUT
!!
!! SIDE EFFECTS
!! at output paw_atdata is deallocated
!!
!! NOTES
!!
!! PARENTS
!!      pspatm_abinit
!!
!! CHILDREN
!!      pawrad_destroy_array
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

#include "abi_common.h"

subroutine paw_atdata_deallocate(paw_atdata)

 use defs_basis
 use m_profiling
 use defs_abitypes
 use m_errors
 use m_pawrad, only : pawrad_type, pawrad_destroy_array

!This section has been created automatically by the script Abilint (TD).
!Do not modify the following lines by hand.
#undef ABI_FUNC
#define ABI_FUNC 'paw_atdata_deallocate'
!End of the abilint section

 implicit none

!Arguments ------------------------------------
 type(paw_atdata_type),intent(inout) :: paw_atdata

!Local variables-------------------------------
 
! *************************************************************************

 if(allocated(paw_atdata%radmesh)) then
   call pawrad_destroy_array(paw_atdata%radmesh)
   ABI_DATATYPE_DEALLOCATE(paw_atdata%radmesh)
 end if
 if(allocated(paw_atdata%shpf)) then
   ABI_DEALLOCATE(paw_atdata%shpf)
 end if
 if(allocated(paw_atdata%tnvale0)) then
   ABI_DEALLOCATE(paw_atdata%tnvale0)
 end if
 if(allocated(paw_atdata%ncore)) then
   ABI_DEALLOCATE(paw_atdata%ncore)
 end if
 if(allocated(paw_atdata%tncore)) then
   ABI_DEALLOCATE(paw_atdata%tncore)
 end if
 if(allocated(paw_atdata%vlocr)) then
   ABI_DEALLOCATE(paw_atdata%vlocr)
 end if
 
end subroutine paw_atdata_deallocate

!!***

